/* mfaim
 * Copyright (c) 1999 Josh Myer <josh@joshisanerd.com>
 * console-mode AIM client
 *
 * mfaim is based on naim;
 *  naim is Copyright (c) 1998, 1999 Daniel Reed <n@ml.org>
 * 
 * mfaim also uess libfaim,
 *  FAIM is Copyright 1998 Adam Fritzler <afritz@iname.com>
 *  FAIM uses code Copyright 1998 Brock Wilcox <awwaiid@iname.com>
 */

#include <mfaim.h>

extern WINDOW	*win_status;
extern struct aim_conn_t       *nfaim_conn;
extern struct aim_session_t mfaim_session;
extern buddywin_t nullbwin;
extern mfaimses_t       mfaimses;

time_t idletime = 0;
int sentidle = 0;
time_t lasttime = 0;

void updateidletime(void) {
  time_t t = time(NULL);
	
  sentidle = 0;
  assert(t != 0);
  idletime = t;
}

void event_handle(time_t now) {
  static int tprint, autoaway;
 
  wdisplay_update(now);

  debug_printf("event_handle(%lu)\n", now);
 
  tprint = secs_getvar_int("tprint");
  autoaway = secs_getvar_int("autoaway");

  if (mfaimses.connected && !sentidle && ((now - idletime) > 1)) {
    sentidle = 1;
    aim_bos_setidle(&mfaim_session, nfaim_conn, now - idletime);
  }

  if ((autoaway > 0) && ((now - idletime) >= (60*autoaway)) && (nullbwin.away == 0)) {
    printf("You have been idle for more than %i minutes.\n", autoaway);
    setaway();
  }

  if (tprint != 0) {
    if(lasttime == 0) /* handle init */
      lasttime = now;

    if((now - lasttime)%(tprint*60) == 0) { /* tprint = "13" was broken. */
      struct tm	*tmptr;
      tmptr = localtime(&now);
      hwprintf(win_status, IMWIN_TEXT_U, "<I>-----</I>[<B>%02i</B>:<B>%02i</B>]<I>-----</I><br>", tmptr->tm_hour, tmptr->tm_min);
      lasttime = now;
    }
    
  }
  return;
}
